// +build !generate_numeric

package hit

import minitest "github.com/Eun/go-hit/internal/minitest"

// ⚠️⚠️⚠️ This file was autogenerated by generators/expect/numeric ⚠️⚠️⚠️ //

// IExpectUint provides assertions for the uint type.
type IExpectUint interface {
	// Equal expects the uint to be equal to the specified value.
	Equal(value uint) IStep

	// NotEqual expects the uint to be not equal to the specified value.
	NotEqual(value ...uint) IStep

	// OneOf expects the uint to be equal to one of the specified values.
	OneOf(values ...uint) IStep

	// NotOneOf expects the uint to be not equal to one of the specified values.
	NotOneOf(values ...uint) IStep

	// GreaterThan expects the uint to be not greater than the specified value.
	GreaterThan(value uint) IStep

	// LessThan expects the uint to be less than the specified value.
	LessThan(value uint) IStep

	// GreaterOrEqualThan expects the uint to be greater or equal than the specified value.
	GreaterOrEqualThan(value uint) IStep

	// LessOrEqualThan expects the uint to be less or equal than the specified value.
	LessOrEqualThan(value uint) IStep

	// Between expects the uint to be between the specified min and max value (inclusive, min >= uint >= max).
	Between(min, max uint) IStep

	// NotBetween expects the uint to be not between the specified min and max value (inclusive, min >= uint >= max).
	NotBetween(min, max uint) IStep
}
type expectUintValueCallback func(hit Hit) uint
type expectUint struct {
	cp            callPath
	valueCallback expectUintValueCallback
}

func newExpectUint(cp callPath, valueCallback expectUintValueCallback) IExpectUint {
	return &expectUint{cp: cp, valueCallback: valueCallback}
}
func (v *expectUint) Equal(value uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Equal", []interface{}{value}), Exec: func(hit *hitImpl) error {
		return minitest.Equal(v.valueCallback(hit), value)
	}}
}
func (v *expectUint) NotEqual(values ...uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotEqual", uintSliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.NotEqual(v.valueCallback(hit), uintSliceToInterfaceSlice(values)...)
	}}
}
func (v *expectUint) OneOf(values ...uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("OneOf", uintSliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.OneOf(v.valueCallback(hit), uintSliceToInterfaceSlice(values)...)
	}}
}
func (v *expectUint) NotOneOf(values ...uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotOneOf", uintSliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.NotOneOf(v.valueCallback(hit), uintSliceToInterfaceSlice(values)...)
	}}
}
func (v *expectUint) GreaterThan(value uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l <= value {
			return minitest.Errorf("expected %d to be greater than %d", l, value)
		}
		return nil
	}}
}
func (v *expectUint) LessThan(value uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= value {
			return minitest.Errorf("expected %d to be less than %d", l, value)
		}
		return nil
	}}
}
func (v *expectUint) GreaterOrEqualThan(value uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < value {
			return minitest.Errorf("expected %d to be greater or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectUint) LessOrEqualThan(value uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l > value {
			return minitest.Errorf("expected %d to be less or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectUint) Between(min, max uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Between", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < min || l > max {
			return minitest.Errorf("expected %d to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
func (v *expectUint) NotBetween(min, max uint) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotBetween", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= min && l <= max {
			return minitest.Errorf("expected %d not to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
